#Multi3

For this test, we will use the toolset to look at the instructions executed by driver-multi3-int.c. This program will read a list of numbers from an input file, multiply them by 3, then write the new set of numbers to an output file.

* The first thing we need is a binary to gather a trace of, so let's compile the program and setup our environment. There is a setup script in the Tools directory that will set up all of the enviornment variables we will need.

`source ../../setup.sh`

* Now that we have an executable, we can gather a trace using the tracer. Since we just want to explore the executable today, we want to make sure the trace contains as much information as possible, meaning we won't turn off an of the fields. Additionally, since we've never run this trace before and want to make sure the reader's state is being maintained properly, we will make the trace print out the source registers and memory reads. These typically aren't on because they shouldn't provide any additional information about a trace, but they do allow the reader to check itself.

`$PIN/pin -t $TRACER64/Tracer.so -srcreg -memread -- ./multi3 numbers.in`

* If we check what's in the current directory, we will see that there are several new files: data.out errors.out trace.out and numbers.in.out. The first 3 were generated by the tracer and the last by the program we analyzed. The data.out file is simply used as a temporary file by the tracer and can be ignored. The errors.out file reports any issues the tracer encountered while analyzing the trace and should be empty. Finally trace.out is the actual trace and is typically the only file that you need to worry about. Now that we have the trace, we can use the trace2ascii program to look at the instructions.

`$TRACE2ASCII/trace2ascii trace.out > ascii.out 2> err.out`

* Now we can check out the output files. The err.out file contains any issues that the reader encountered. There will probably be some warnings in the file. If you look through the file, there should only be warnings mentioning RIP mismatches and some memory read issues involving the fs register. All of those warnings are fine, we are currently working on fixing them but they also shouldn't affect much. If we now look at ascii.out, we can see all of the instructions executed by the program. A line in the file is formatted like so:

  tid address source function binary disassembly

* At this point, some of you might want to write your own programs to analyze a trace. We aren't going to go through that in this tutorial, but make sure you read the readme in the reader directory and trace2ascii.c in the trace2ascii folder provides a good example.

