/* driver-mult3-int.c
   C program that reads integers listed one per line, multiplies each double by 3,
   and then creates an output file.
        gcc -O2 driver-mult3-int.c -o driver-mult3
        ./driver-mult3-int infile
   This example is nice because...
        - Scientists typically create a workflow with files as 
          inputs and outputs
        - The loop is not automatically parallelizable because of the writes 
          to the output file.
          However, the multiplications can definitely be done in parallel.
 */

#include <stdio.h>
#include <string.h>

int main(int argc, char **argv) {

    // Open the input file and an output file.
    if (argc<2) {
        fprintf(stderr, "usage: ./driver-mult3-int infile\n");
        return 1;
    }
    FILE *infile = fopen(argv[1],"r");
    char *outfilename = strcat(argv[1],".out");
    FILE *outfile = fopen(outfilename,"w");

    // Read in all the integers, multiply each float by 3, 
    // and then put them in the output file.
    int in;
    while (fscanf(infile,"%d", &in)!=EOF) {
        fprintf(outfile, "%d\n", in*3);
    }

    return 0;
}
