/*
 * File: interp.h
 * Author: Saumya Debray *
 * Purpose: Definitions for the interpreter
 */

#ifndef _INTERP_H_
#define _INTERP_H_

/*
 * Opcodes
 */
#define MOV	  0
#define ADD	  1
#define SUB	  2
#define MUL	  3
#define DIV	  4
#define IF_GE	  5
#define IF_GT	  6
#define IF_LE	  7
#define IF_LT	  8
#define IF_EQ	  9
#define IF_NE	 10
#define JMP	 11
#define PRINT    12
#define HALT	 13

/*
 * Operand types
 */
#define REG	  'r'
#define MEM	  'm'
#define IMM	  'i'
#define INDIR	  '*'
#define NONE      '-'


typedef struct operand {
  char type;  // reg, memory, or immediate
  int  value;
} Operand;


typedef struct instr {
  char opcode;
  Operand src1, src2, dest;
} Instr;

#define NREGS		8
#define NMEM		1024

#endif  /*  _INTERP_H_ */
