/*
* File: TrdAscii.h
* Author: David Raicher
* Description: This file contains all of the backend created for the Ascii format of the trace reader.
* Note that most of the outward facing functions from this file are desposited in function pointers inside
* of Trd.c.  Future formats will likely want to follow the same process.
*/

#ifndef _TRD_INFO_SEL_H_
#define _TRD_INFO_SEL_H_

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <ctype.h>
#include <inttypes.h>
#include "ReaderUtils.h"
#include "Reader.h"
#include "ShadowRegisters.h"
#include "ShadowMemory.h"
#include "../shared/LynxReg.h"
#include "../shared/header.h"

void initDataOps (FileHeader *fileHeader, SectionEntry *sectionTable, FILE *traceFile);

uint32_t readDataOpsEvent (ReaderEvent *nextEvent, uint64_t curId, InsInfo *curInfo);

const char *fetchDataOpsStr(uint32_t id);

void freeDataOps();

#endif
