#Tools
The Tools directory in the ScienceUpToPar repository is where we will store all of the tools we are developing to aid in the ScienceUpToPar project.

##Organization
The tools directory is organized as follows:

* Tracer - The tracer is a pintool that will be used to generate traces in the UA trace format.
* Reader - The reader is a library that can be used by other tools to allow them to read UA traces.
* Shared - The shared directory is for resources that need to be included by multiple projects.
* Trace2Ascii - A tool that reads a trace using the reader, then prints its contents out in a human readable form.
* Examples - The directory that contains examples about how to use the Tools. Each example has its own README with instructions.

##Quickstart
For those who want to begin as quickly as possible, here are the main commands:

###Setup
To make it easier to use the tools, a setup script has been provided in this directory. It will set up environment variables to make varies tools easier to access; however, it does assume that the structure specified by the README in the Tracer directory has been followed. If this is the case, just execute:

`source setup.sh`

###Tracer
To gather a trace, just execute the following command:

`$PIN/pin -t $TRACER64/Tracer.so [Tracer Arguments] -- <Executable> [Executable Arguments]`

Note, the 'Tracer Arguments' are shown in the README of the tracer directory.

For example, say we wanted to take a trace of a python executing some python script 'scripy.py'. Additionally, we want to allow the reader to perform self-checks to ensure its state is consistent. For this, we would execute:

`$PIN/pin -t $TRACER64/Tracer.so -srcreg -memread -- python script.py`

###Reader
The reader is just a library, so there is usage that applies to the reader. For advise on how to build the Reader and the API for interfacing with the reader, please see the README in the Reader folder.

###Trace2Ascii
The trace2ascii program just provides a plaintext version of the trace so that a human can read the trace. It should be noted that the output is printed to standard out, so the recommended usage is:

`$TRACE2ASCII/trace2ascii <trace> > <file>`

For example, if we wanted to see the instructions from 'trace.out', we would use the following command:

`$TRACE2ASCII/trace2ascii trace.out > ascii.out`
