#include "XedLynxReg.h"
#include "header.h"
#include <stdio.h>

LynxReg xedReg2LynxReg (xed_reg_enum_t reg, ArchType arch)
{
    switch (reg) {
    case XED_REG_RFLAGS:
    case XED_REG_EFLAGS:
        return LYNX_GFLAGS;
	case XED_REG_ZMM0:
	    return LYNX_ZMM0;
	case XED_REG_ZMM1:
	    return LYNX_ZMM1;
	case XED_REG_ZMM2:
	    return LYNX_ZMM2;
	case XED_REG_ZMM3:
	    return LYNX_ZMM3;
	case XED_REG_ZMM4:
	    return LYNX_ZMM4;
	case XED_REG_ZMM5:
	    return LYNX_ZMM5;
	case XED_REG_ZMM6:
	    return LYNX_ZMM6;
	case XED_REG_ZMM7:
	    return LYNX_ZMM7;
	case XED_REG_ZMM8:
	    return LYNX_ZMM8;
	case XED_REG_ZMM9:
	    return LYNX_ZMM9;
	case XED_REG_ZMM10:
	    return LYNX_ZMM10;
	case XED_REG_ZMM11:
	    return LYNX_ZMM11;
	case XED_REG_ZMM12:
	    return LYNX_ZMM12;
	case XED_REG_ZMM13:
	    return LYNX_ZMM13;
	case XED_REG_ZMM14:
	    return LYNX_ZMM14;
	case XED_REG_ZMM15:
	    return LYNX_ZMM15;
	case XED_REG_ZMM16:
	    return LYNX_ZMM16;
	case XED_REG_ZMM17:
	    return LYNX_ZMM17;
	case XED_REG_ZMM18:
	    return LYNX_ZMM18;
	case XED_REG_ZMM19:
	    return LYNX_ZMM19;
	case XED_REG_ZMM20:
	    return LYNX_ZMM20;
	case XED_REG_ZMM21:
	    return LYNX_ZMM21;
	case XED_REG_ZMM22:
	    return LYNX_ZMM22;
	case XED_REG_ZMM23:
	    return LYNX_ZMM23;
	case XED_REG_ZMM24:
	    return LYNX_ZMM24;
	case XED_REG_ZMM25:
	    return LYNX_ZMM25;
	case XED_REG_ZMM26:
	    return LYNX_ZMM26;
	case XED_REG_ZMM27:
	    return LYNX_ZMM27;
	case XED_REG_ZMM28:
	    return LYNX_ZMM28;
	case XED_REG_ZMM29:
	    return LYNX_ZMM29;
	case XED_REG_ZMM30:
	    return LYNX_ZMM30;
	case XED_REG_ZMM31:
	    return LYNX_ZMM31;
	case XED_REG_K0:
	    return LYNX_K0;
	case XED_REG_K1:
	    return LYNX_K1;
	case XED_REG_K2:
	    return LYNX_K2;
	case XED_REG_K3:
	    return LYNX_K3;
	case XED_REG_K4:
	    return LYNX_K4;
	case XED_REG_K5:
	    return LYNX_K5;
	case XED_REG_K6:
	    return LYNX_K6;
	case XED_REG_K7:
	    return LYNX_K7;
	case XED_REG_RIP:
	    return LYNX_RIP;
	case XED_REG_RAX:
	    return LYNX_RAX;
	case XED_REG_RBX:
	    return LYNX_RBX;
	case XED_REG_RCX:
	    return LYNX_RCX;
	case XED_REG_RDX:
	    return LYNX_RDX;
	case XED_REG_RBP:
	    return LYNX_RBP;
	case XED_REG_RSI:
	    return LYNX_RSI;
	case XED_REG_RDI:
	    return LYNX_RDI;
	case XED_REG_RSP:
	    return LYNX_RSP;
	case XED_REG_R8:
	    return LYNX_R8;
	case XED_REG_R9:
	    return LYNX_R9;
	case XED_REG_R10:
	    return LYNX_R10;
	case XED_REG_R11:
	    return LYNX_R11;
	case XED_REG_R12:
	    return LYNX_R12;
	case XED_REG_R13:
	    return LYNX_R13;
	case XED_REG_R14:
	    return LYNX_R14;
	case XED_REG_R15:
	    return LYNX_R15;
	case XED_REG_CS:
	    return LYNX_SEG_CS;
	case XED_REG_DS:
	    return LYNX_SEG_DS;
	case XED_REG_ES:
	    return LYNX_SEG_ES;
	case XED_REG_FS:
	    return LYNX_SEG_FS;
	case XED_REG_GS:
	    return LYNX_SEG_GS;
	case XED_REG_SS:
	    return LYNX_SEG_SS;
	case XED_REG_MXCSR:
	    return LYNX_MXCSR;
	case XED_REG_ST0:
	    return LYNX_ST0;
	case XED_REG_ST1:
	    return LYNX_ST1;
	case XED_REG_ST2:
	    return LYNX_ST2;
	case XED_REG_ST3:
	    return LYNX_ST3;
	case XED_REG_ST4:
	    return LYNX_ST4;
	case XED_REG_ST5:
	    return LYNX_ST5;
	case XED_REG_ST6:
	    return LYNX_ST6;
	case XED_REG_ST7:
	    return LYNX_ST7;
	case XED_REG_DR0:
	    return LYNX_DR0;
	case XED_REG_DR1:
	    return LYNX_DR1;
	case XED_REG_DR2:
	    return LYNX_DR2;
	case XED_REG_DR3:
	    return LYNX_DR3;
	case XED_REG_DR4:
	    return LYNX_DR4;
	case XED_REG_DR5:
	    return LYNX_DR5;
	case XED_REG_DR6:
	    return LYNX_DR6;
	case XED_REG_DR7:
	    return LYNX_DR7;
	case XED_REG_CR0:
	    return LYNX_CR0;
	case XED_REG_CR1:
	    return LYNX_CR1;
	case XED_REG_CR2:
	    return LYNX_CR2;
	case XED_REG_CR3:
	    return LYNX_CR3;
	case XED_REG_CR4:
	    return LYNX_CR4;
	case XED_REG_YMM0:
	    return LYNX_YMM0;
	case XED_REG_YMM1:
	    return LYNX_YMM1;
	case XED_REG_YMM2:
	    return LYNX_YMM2;
	case XED_REG_YMM3:
	    return LYNX_YMM3;
	case XED_REG_YMM4:
	    return LYNX_YMM4;
	case XED_REG_YMM5:
	    return LYNX_YMM5;
	case XED_REG_YMM6:
	    return LYNX_YMM6;
	case XED_REG_YMM7:
	    return LYNX_YMM7;
	case XED_REG_EIP:
	    return LYNX_EIP;
	case XED_REG_EAX:
	    return LYNX_EAX;
	case XED_REG_EBX:
	    return LYNX_EBX;
	case XED_REG_ECX:
	    return LYNX_ECX;
	case XED_REG_EDX:
	    return LYNX_EDX;
	case XED_REG_EBP:
	    return LYNX_EBP;
	case XED_REG_ESI:
	    return LYNX_ESI;
	case XED_REG_EDI:
	    return LYNX_EDI;
	case XED_REG_ESP:
	    return LYNX_ESP;
	case XED_REG_R8D:
	    return LYNX_R8D;
	case XED_REG_R9D:
	    return LYNX_R9D;
	case XED_REG_R10D:
	    return LYNX_R10D;
	case XED_REG_R11D:
	    return LYNX_R11D;
	case XED_REG_R12D:
	    return LYNX_R12D;
	case XED_REG_R13D:
	    return LYNX_R13D;
	case XED_REG_R14D:
	    return LYNX_R14D;
	case XED_REG_R15D:
	    return LYNX_R15D;
	case XED_REG_IP:
	    return LYNX_IP;
	case XED_REG_AX:
	    return LYNX_AX;
	case XED_REG_BX:
	    return LYNX_BX;
	case XED_REG_CX:
	    return LYNX_CX;
	case XED_REG_DX:
	    return LYNX_DX;
	case XED_REG_BP:
	    return LYNX_BP;
	case XED_REG_SI:
	    return LYNX_SI;
	case XED_REG_DI:
	    return LYNX_DI;
	case XED_REG_SP:
	    return LYNX_SP;
	case XED_REG_R8W:
	    return LYNX_R8W;
	case XED_REG_R9W:
	    return LYNX_R9W;
	case XED_REG_R10W:
	    return LYNX_R10W;
	case XED_REG_R11W:
	    return LYNX_R11W;
	case XED_REG_R12W:
	    return LYNX_R12W;
	case XED_REG_R13W:
	    return LYNX_R13W;
	case XED_REG_R14W:
	    return LYNX_R14W;
	case XED_REG_R15W:
	    return LYNX_R15W;
	case XED_REG_AH:
	    return LYNX_AH;
	case XED_REG_BH:
	    return LYNX_BH;
	case XED_REG_CH:
	    return LYNX_CH;
	case XED_REG_DH:
	    return LYNX_DH;
	case XED_REG_AL:
	    return LYNX_AL;
	case XED_REG_BL:
	    return LYNX_BL;
	case XED_REG_CL:
	    return LYNX_CL;
	case XED_REG_DL:
	    return LYNX_DL;
	case XED_REG_BPL:
	    return LYNX_BPL;
	case XED_REG_SIL:
	    return LYNX_SIL;
	case XED_REG_DIL:
	    return LYNX_DIL;
	case XED_REG_SPL:
	    return LYNX_SPL;
	case XED_REG_R8B:
	    return LYNX_R8B;
	case XED_REG_R9B:
	    return LYNX_R9B;
	case XED_REG_R10B:
	    return LYNX_R10B;
	case XED_REG_R11B:
	    return LYNX_R11B;
	case XED_REG_R12B:
	    return LYNX_R12B;
	case XED_REG_R13B:
	    return LYNX_R13B;
	case XED_REG_R14B:
	    return LYNX_R14B;
	case XED_REG_R15B:
	    return LYNX_R15B;
	case XED_REG_YMM8:
	    return LYNX_YMM8;
	case XED_REG_YMM9:
	    return LYNX_YMM9;
	case XED_REG_YMM10:
	    return LYNX_YMM10;
	case XED_REG_YMM11:
	    return LYNX_YMM11;
	case XED_REG_YMM12:
	    return LYNX_YMM12;
	case XED_REG_YMM13:
	    return LYNX_YMM13;
	case XED_REG_YMM14:
	    return LYNX_YMM14;
	case XED_REG_YMM15:
	    return LYNX_YMM15;
	case XED_REG_YMM16:
	    return LYNX_YMM16;
	case XED_REG_YMM17:
	    return LYNX_YMM17;
	case XED_REG_YMM18:
	    return LYNX_YMM18;
	case XED_REG_YMM19:
	    return LYNX_YMM19;
	case XED_REG_YMM20:
	    return LYNX_YMM20;
	case XED_REG_YMM21:
	    return LYNX_YMM21;
	case XED_REG_YMM22:
	    return LYNX_YMM22;
	case XED_REG_YMM23:
	    return LYNX_YMM23;
	case XED_REG_YMM24:
	    return LYNX_YMM24;
	case XED_REG_YMM25:
	    return LYNX_YMM25;
	case XED_REG_YMM26:
	    return LYNX_YMM26;
	case XED_REG_YMM27:
	    return LYNX_YMM27;
	case XED_REG_YMM28:
	    return LYNX_YMM28;
	case XED_REG_YMM29:
	    return LYNX_YMM29;
	case XED_REG_YMM30:
	    return LYNX_YMM30;
	case XED_REG_YMM31:
	    return LYNX_YMM31;
	case XED_REG_XMM0:
	    return LYNX_XMM0;
	case XED_REG_XMM1:
	    return LYNX_XMM1;
	case XED_REG_XMM2:
	    return LYNX_XMM2;
	case XED_REG_XMM3:
	    return LYNX_XMM3;
	case XED_REG_XMM4:
	    return LYNX_XMM4;
	case XED_REG_XMM5:
	    return LYNX_XMM5;
	case XED_REG_XMM6:
	    return LYNX_XMM6;
	case XED_REG_XMM7:
	    return LYNX_XMM7;
	case XED_REG_XMM8:
	    return LYNX_XMM8;
	case XED_REG_XMM9:
	    return LYNX_XMM9;
	case XED_REG_XMM10:
	    return LYNX_XMM10;
	case XED_REG_XMM11:
	    return LYNX_XMM11;
	case XED_REG_XMM12:
	    return LYNX_XMM12;
	case XED_REG_XMM13:
	    return LYNX_XMM13;
	case XED_REG_XMM14:
	    return LYNX_XMM14;
	case XED_REG_XMM15:
	    return LYNX_XMM15;
	case XED_REG_XMM16:
	    return LYNX_XMM16;
	case XED_REG_XMM17:
	    return LYNX_XMM17;
	case XED_REG_XMM18:
	    return LYNX_XMM18;
	case XED_REG_XMM19:
	    return LYNX_XMM19;
	case XED_REG_XMM20:
	    return LYNX_XMM20;
	case XED_REG_XMM21:
	    return LYNX_XMM21;
	case XED_REG_XMM22:
	    return LYNX_XMM22;
	case XED_REG_XMM23:
	    return LYNX_XMM23;
	case XED_REG_XMM24:
	    return LYNX_XMM24;
	case XED_REG_XMM25:
	    return LYNX_XMM25;
	case XED_REG_XMM26:
	    return LYNX_XMM26;
	case XED_REG_XMM27:
	    return LYNX_XMM27;
	case XED_REG_XMM28:
	    return LYNX_XMM28;
	case XED_REG_XMM29:
	    return LYNX_XMM29;
	case XED_REG_XMM30:
	    return LYNX_XMM30;
	case XED_REG_XMM31:
	    return LYNX_XMM31;
	case XED_REG_MMX0:
	    return LYNX_MM0;
	case XED_REG_MMX1:
	    return LYNX_MM1;
	case XED_REG_MMX2:
	    return LYNX_MM2;
	case XED_REG_MMX3:
	    return LYNX_MM3;
	case XED_REG_MMX4:
	    return LYNX_MM4;
	case XED_REG_MMX5:
	    return LYNX_MM5;
	case XED_REG_MMX6:
	    return LYNX_MM6;
	case XED_REG_MMX7:
	    return LYNX_MM7;
	case XED_REG_X87CONTROL:
	    return LYNX_FPCW;
	case XED_REG_X87STATUS:
	    return LYNX_FPSW;
	case XED_REG_X87TAG:
	    return LYNX_FPTAG_FULL;
    case XED_REG_STACKPUSH:
    case XED_REG_STACKPOP:
        if(arch == X86_ARCH) {
            return LYNX_ESP;
        }
        else if(arch == X86_64_ARCH) {
            return LYNX_RSP;
        }
        return LYNX_INVALID;
	case XED_REG_INVALID:
	    return LYNX_INVALID;
	default:
        fprintf(stderr, "Warning: Unknown xed reg %s\n", xed_reg_enum_t2str(reg));
	    return LYNX_INVALID;
    }
}
